﻿'------------------------------------------
'Sabotile by Alun Hancock, 2014
'------------------------------------------
'CTRL M H to hide code blocks
'CTRL M U to unhide

Option Explicit On

Imports System.String
Imports System.Drawing
Imports System.Drawing.Color
Imports System.Windows.Forms.PictureBox
Imports System.Windows.Forms.Keys

Public Class form_World
    'Global Variables and Objects
    Dim player_X, player_Y As Integer

    'Private MonsterHPcur(21), MonsterHPmax(21) As Integer
    'Private MonsterX(21), MonsterY(21) As Integer
    'Private MonsterAlive(21) As Boolean
    'Private pic_monster(21) As System.Windows.Forms.PictureBox
    'Dim pic_player As System.Windows.Forms.PictureBox

    Dim GameMap(31, 33) As Integer
    Const Tile_Air = 0      'passable, fall
    Const Tile_Wall = 1     'blocked
    Const Tile_Water = 2    'passable horizontally
    Const Tile_Ladder = 3   'passable vertically and horizontally
    Const Tile_Disk = 4     'passable - triggers inventory
    Const Tile_Exit = 5     'passable - triggers victory if disk held

    Dim Number_of_Doors As Integer = 6 'zero based array
    Dim pic_SecurityDoor(Number_of_Doors) As SecurityDoor
    Dim pic_Computer(Number_of_Doors) As Computer

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Check for falling player
        If (GameMap(player_X, player_Y + 1) = Tile_Air Or GameMap(player_X, player_Y + 1) = Tile_Water Or GameMap(player_X, player_Y + 1) = Tile_Exit) And GameMap(player_X, player_Y) <> Tile_Ladder Then
            player_Y = player_Y + 1
            Check_After_Move()
        End If
    End Sub

    Private Sub form_World_KeyUp(sender As Object, e As KeyEventArgs) Handles Me.KeyUp
        'Form properties > Misc > Key Preview = True to enable form-wide keyboard input.
        Select e.KeyCode
            Case Keys.Up 'if your square is air (not a ladder), and the square below you is air (not a ladder) then climbing is not allowed
                If player_Y > 1 And Map_Check_Target_Square(player_X, player_Y - 1) = True And Not (GameMap(player_X, player_Y + 1) = Tile_Air And GameMap(player_X, player_Y) = Tile_Air) Then player_Y = player_Y - 1
            Case Keys.Down
                If player_Y < 32 And Map_Check_Target_Square(player_X, player_Y + 1) = True Then player_Y = player_Y + 1
            Case Keys.Left
                If player_X > 1 And Map_Check_Target_Square(player_X - 1, player_Y) = True Then player_X = player_X - 1
            Case Keys.Right
                If player_X < 30 And Map_Check_Target_Square(player_X + 1, player_Y) = True Then player_X = player_X + 1
            Case Else
        End Select
        Check_After_Move()
    End Sub

    Private Sub Check_After_Move()
        Dim x As Integer
        '8 pixel border around the map of 16*16 size elements
        pic_player.Location = New System.Drawing.Point((player_X * 16) + 8, (player_Y * 16) - 8)

        'grabbing the disk
        If GameMap(player_X, player_Y) = Tile_Disk Then
            pic_DiskEnabled.Visible = True
            For x = 0 To Number_of_Doors 'security turns on the computers and doors again
                pic_Computer(x).Turn_On()
                pic_SecurityDoor(x).Visible = True
            Next
        End If

        'WIN THE GAME
        If GameMap(player_X, player_Y) = Tile_Exit And pic_DiskEnabled.Visible = True Then
            MsgBox("You escape with the disk. Game Over.")
            End
        End If

        'check if there is a computer here and remove the connected security door
        '--- security doors are checked *before* the move to block the player
        For x = 0 To Number_of_Doors
            If pic_Computer(x).computer_X = player_X And pic_Computer(x).computer_Y = player_Y Then
                pic_Computer(x).Turn_Off()
                pic_SecurityDoor(x).Visible = False
            End If
        Next

    End Sub

    Private Sub form_World_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        'Build the world map
        Dim X, Y As Integer
        For Y = 1 To 33
            For X = 0 To 30 ' Substring uses 0 as the first character, not 1
                If Y = 1 Then GameMap(X, Y) = "0000000000000000000000000000000".Substring(X, 1)
                If Y = 2 Then GameMap(X, Y) = "0000000000000000000000001100110".Substring(X, 1)
                If Y = 3 Then GameMap(X, Y) = "0000000000000000111100100011000".Substring(X, 1)
                If Y = 4 Then GameMap(X, Y) = "0000000000000000100011100511000".Substring(X, 1)
                If Y = 5 Then GameMap(X, Y) = "0000000000000001100000000511100".Substring(X, 1)
                If Y = 6 Then GameMap(X, Y) = "0000000000000001113111111111110".Substring(X, 1)
                If Y = 7 Then GameMap(X, Y) = "0000000000111111113111100000010".Substring(X, 1)
                If Y = 8 Then GameMap(X, Y) = "0000000000111110013011100000010".Substring(X, 1)
                If Y = 9 Then GameMap(X, Y) = "0000000000100000013000000000010".Substring(X, 1)
                If Y = 10 Then GameMap(X, Y) = "0000000000100311111111111111310".Substring(X, 1)
                If Y = 11 Then GameMap(X, Y) = "0000000000100311000100000001310".Substring(X, 1)
                If Y = 12 Then GameMap(X, Y) = "0000000000100311000100313001310".Substring(X, 1)
                If Y = 13 Then GameMap(X, Y) = "0000000000100300000000313000310".Substring(X, 1)
                If Y = 14 Then GameMap(X, Y) = "0000000000111111131111111111110".Substring(X, 1)
                If Y = 15 Then GameMap(X, Y) = "0000000000100111030100000011110".Substring(X, 1)
                If Y = 16 Then GameMap(X, Y) = "0000000000100111030003111311110".Substring(X, 1)
                If Y = 17 Then GameMap(X, Y) = "0000000000100000030003100300010".Substring(X, 1)
                If Y = 18 Then GameMap(X, Y) = "0000000000111113111111111111310".Substring(X, 1)
                If Y = 19 Then GameMap(X, Y) = "0000000000000003110000000000311".Substring(X, 1)
                If Y = 20 Then GameMap(X, Y) = "2222222111131111100000000130311".Substring(X, 1)
                If Y = 21 Then GameMap(X, Y) = "2222222222130011131111311111111".Substring(X, 1)
                If Y = 22 Then GameMap(X, Y) = "1111111111111111131111311111111".Substring(X, 1)
                If Y = 23 Then GameMap(X, Y) = "1100000000001111131111311111111".Substring(X, 1)
                If Y = 24 Then GameMap(X, Y) = "1100001111101111030011311100011".Substring(X, 1)
                If Y = 25 Then GameMap(X, Y) = "1100001004101111030010300100011".Substring(X, 1)
                If Y = 26 Then GameMap(X, Y) = "1100001311101111311310300131311".Substring(X, 1)
                If Y = 27 Then GameMap(X, Y) = "1100000300101111311311111131311".Substring(X, 1)
                If Y = 28 Then GameMap(X, Y) = "1131131111101110311300000031311".Substring(X, 1)
                If Y = 29 Then GameMap(X, Y) = "1131101111101110311111111111311".Substring(X, 1)
                If Y = 30 Then GameMap(X, Y) = "1130000000000011111111111000311".Substring(X, 1)
                If Y = 31 Then GameMap(X, Y) = "1111111111111001111111110011111".Substring(X, 1)
                If Y = 32 Then GameMap(X, Y) = "1111111111111100000000000111111".Substring(X, 1)
                If Y = 33 Then GameMap(X, Y) = "1111111111111111111111111111111".Substring(X, 1)
            Next X
        Next Y

        'Place security doors and computers on the map
        For X = 0 To Number_of_Doors
            pic_SecurityDoor(X) = New SecurityDoor
            Picture_Map.Controls.Add(pic_SecurityDoor(X))
            pic_Computer(X) = New Computer
            Picture_Map.Controls.Add(pic_Computer(X))
        Next

        pic_SecurityDoor(0).door_X = 13
        pic_SecurityDoor(0).door_Y = 17
        pic_SecurityDoor(0).Location = New System.Drawing.Point((pic_SecurityDoor(0).door_X * 16) + 8, (pic_SecurityDoor(0).door_Y * 16) - 7)
        pic_Computer(0).computer_X = 13
        pic_Computer(0).computer_Y = 21
        pic_Computer(0).Location = New System.Drawing.Point((pic_Computer(0).computer_X * 16) + 14, (pic_Computer(0).computer_Y * 16) - 7)

        pic_SecurityDoor(1).door_X = 24
        pic_SecurityDoor(1).door_Y = 17
        pic_SecurityDoor(1).Location = New System.Drawing.Point((pic_SecurityDoor(1).door_X * 16) + 8, (pic_SecurityDoor(1).door_Y * 16) - 7)
        pic_Computer(1).computer_X = 11
        pic_Computer(1).computer_Y = 17
        pic_Computer(1).Location = New System.Drawing.Point((pic_Computer(1).computer_X * 16) + 8, (pic_Computer(1).computer_Y * 16) - 7)

        pic_SecurityDoor(2).door_X = 14
        pic_SecurityDoor(2).door_Y = 13
        pic_SecurityDoor(2).Location = New System.Drawing.Point((pic_SecurityDoor(2).door_X * 16) + 8, (pic_SecurityDoor(2).door_Y * 16) - 7)
        pic_Computer(2).computer_X = 23
        pic_Computer(2).computer_Y = 17
        pic_Computer(2).Location = New System.Drawing.Point((pic_Computer(2).computer_X * 16) + 8, (pic_Computer(2).computer_Y * 16) - 7)

        pic_SecurityDoor(3).door_X = 14
        pic_SecurityDoor(3).door_Y = 9
        pic_SecurityDoor(3).Location = New System.Drawing.Point((pic_SecurityDoor(3).door_X * 16) + 8, (pic_SecurityDoor(3).door_Y * 16) - 7)
        pic_Computer(3).computer_X = 21
        pic_Computer(3).computer_Y = 26
        pic_Computer(3).Location = New System.Drawing.Point((pic_Computer(3).computer_X * 16) + 8, (pic_Computer(3).computer_Y * 16) - 7)

        pic_SecurityDoor(4).door_X = 21
        pic_SecurityDoor(4).door_Y = 9
        pic_SecurityDoor(4).Location = New System.Drawing.Point((pic_SecurityDoor(4).door_X * 16) + 8, (pic_SecurityDoor(4).door_Y * 16) - 7)
        pic_Computer(4).computer_X = 16
        pic_Computer(4).computer_Y = 9
        pic_Computer(4).Location = New System.Drawing.Point((pic_Computer(4).computer_X * 16) + 14, (pic_Computer(4).computer_Y * 16) - 7)

        pic_SecurityDoor(5).door_X = 27
        pic_SecurityDoor(5).door_Y = 13
        pic_SecurityDoor(5).Location = New System.Drawing.Point((pic_SecurityDoor(5).door_X * 16) + 8, (pic_SecurityDoor(5).door_Y * 16) - 7)
        pic_Computer(5).computer_X = 15
        pic_Computer(5).computer_Y = 29
        pic_Computer(5).Location = New System.Drawing.Point((pic_Computer(5).computer_X * 16) + 8, (pic_Computer(5).computer_Y * 16) - 7)

        pic_SecurityDoor(6).door_X = 19
        pic_SecurityDoor(6).door_Y = 13
        pic_SecurityDoor(6).Location = New System.Drawing.Point((pic_SecurityDoor(6).door_X * 16) + 8, (pic_SecurityDoor(6).door_Y * 16) - 7)
        pic_Computer(6).computer_X = 9
        pic_Computer(6).computer_Y = 27
        pic_Computer(6).Location = New System.Drawing.Point((pic_Computer(6).computer_X * 16) + 14, (pic_Computer(6).computer_Y * 16) - 7)

        'Monster Health and position
        'Dim int_MonsterID As Integer
        'For int_MonsterID = 0 To 21
        'MonsterHPcur(int_MonsterID) = 6 + (int_MonsterID ^ 2)
        'MonsterHPmax(int_MonsterID) = MonsterHPcur(int_MonsterID)
        'MonsterX(int_MonsterID) = (20 - int_MonsterID)
        'MonsterY(int_MonsterID) = int_MonsterID + 1 'Note that I am using conventional Y=0 is the bottom heal line, not screen Y=0 which is the top
        'If int_MonsterID = 21 Then 'corrects automated location for BlackBeast
        '        MonsterX(int_MonsterID) = 20
        'MonsterY(int_MonsterID) = 21
        'End If
        'MonsterAlive(int_MonsterID) = True
        'Next

        'Prepare the Player and Monster graphics
        'pic_player = New System.Windows.Forms.PictureBox
        Picture_Map.Controls.Add(pic_player)
        'pic_player.ImageLocation = Application.StartupPath & "\Graphics\Player.bmp"
        pic_player.Size = New System.Drawing.Size(16, 16)
        player_X = 7
        player_Y = 19
        pic_player.Location = New System.Drawing.Point((player_X * 16) + 8, (player_Y * 16) - 8)
        pic_player.BringToFront()

        'For int_MonsterID = 0 To 21
        'pic_monster(int_MonsterID) = New System.Windows.Forms.PictureBox
        'Picture_Map.Controls.Add(pic_monster(int_MonsterID))
        'pic_monster(int_MonsterID).ImageLocation = Application.StartupPath & "\Graphics\Enemy_" & int_MonsterID & ".bmp"
        'pic_monster(int_MonsterID).Size = New System.Drawing.Size(16, 16)
        'pic_monster(int_MonsterID).Location = New System.Drawing.Point(8 + (MonsterX(int_MonsterID) * 16), 8 + (16 * 21) - (16 * MonsterY(int_MonsterID)))
        'Next int_MonsterID
    End Sub

    Private Function Map_Check_Target_Square(MapX As Integer, MapY As Integer) As Boolean
        Map_Check_Target_Square = False 'false means blocked
        If GameMap(MapX, MapY) = 1 Then
            Return False
        Else
            'check for doors
            Dim doorclash As Boolean = False
            Dim i As Integer
            For i = 0 To Number_of_Doors
                If pic_SecurityDoor(i).door_X = MapX And pic_SecurityDoor(i).door_Y = MapY And pic_SecurityDoor(i).Visible = True Then doorclash = True
            Next i
            If doorclash = False Then Return True Else Return False
        End If
    End Function

End Class
